#!/usr/bin/perl
use strict; 
use warnings;  
use LWP::Simple;  
use LWP::UserAgent;
use FindBin;
use lib $FindBin::Bin;
use ServiceUtil;
use JSON;

package RBAC;

my $ua = LWP::UserAgent->new;
$ua->agent("$0/0.1");

sub login {

    my $serviceSettingsData = ServiceUtil::getServiceSettingsData();
    my $loginUrl = $serviceSettingsData->{ServiceUrls}->{RbacServiceUrl}."/login";

    my $restConfigData = ServiceUtil::getRestConfigData();
    my $loginUserName = $restConfigData->{user};
    my $loginPassPhrase = $restConfigData->{restServiceAdminPassword};
    my $loginContent = '{"UserOperationContext":{"User":{"UserName":"'.$loginUserName.'","Passphrase":"'.$loginPassPhrase.'","TokenNeverExpires":"true"}},"Use128Bit":"true"}';

    # Create a request
    my $req = HTTP::Request->new(POST => $loginUrl);
    $req->content_type('application/json');
    $req->content($loginContent);

    # Pass request to the user agent and get a response back
    my $res = $ua->request($req);
    
    my $responseContent;

    # Check the outcome of the response
    if ($res->is_success) {
        $responseContent = JSON::decode_json($res->content);
        return $responseContent->{user}->{token};
    } else {
        die($res->status_line, "\n");
    }
}