#!/usr/bin/perl
use strict; 
use warnings;  
use JSON;

binmode STDOUT, ":utf8";
use utf8;

package ServiceUtil;

my $restConfigFilePath = '/opt/netapp/controlplane/conf/restservice.conf'; # Remove /c for linux
my $serviceSettingsFilePath = '/opt/netapp/protectionservice/conf/service-settings.conf'; # Remove /c for linux

sub getRestConfigData{

    my $json;
    {
        local $/; #Enable 'slurp' mode
        if(open my $fh, "<$restConfigFilePath"){
            $json = <$fh>;
            close $fh;
            my $offset = index $json, "{";
            $json = substr $json, $offset;
            my $decoder = new JSON;
            return $decoder->loose->decode($json);
        }
        else{
            die("Could not read file $restConfigFilePath", "\n");
        };
    }
    
}

sub getServiceSettingsData{

    my $json;
    {
        local $/; #Enable 'slurp' mode
        if(open my $fh, "<$serviceSettingsFilePath"){
            $json = <$fh>;
            close $fh;
            return JSON::decode_json($json);
        }
        else{
            die("Could not read file $serviceSettingsFilePath", "\n");
        };
    }

}