#!/bin/bash

# $Id$
# Copyright (c) 2012 Network Appliance, Inc.
# All rights reserved.

# Changes the NTP server to the host specified.
# Called by the maintenance console

set -e

CONF_FILE=/etc/ntp.conf

echo

while [[ 1 ]]
do
    read -r -p "Enter NTP server IP address/FQDN (multiple values can be comma separated):" HOST
	declare -a ADDR_ARR
	validHost=true
	count=0

	for addr in $(echo $HOST | tr ',' '\n')
	do
		if [[ $addr =~ ([0-9]{1,3}\.){3}([0-9]){1,3} ]]; then
			ADDR_ARR[count]=$addr
		else
			if ! host $addr > /dev/null 2>&1; then
				validHost=false
				echo "Host \"$addr\" not found. Enter a valid IP address/FQDN."
				while [[ 1 ]]
				do
					read -r -p "Do you wish to continue? (y/n):" answer
					if [ "$answer" == "n" ]  || [ "$answer" == "N" ]; then
						echo
						echo "Changes to NTP server cancelled."
						echo
						exit
					else
						if [ "$answer" == "y" ] || [ "$answer" == "Y" ]; then
							break
						fi
					fi
				done
			else
				ADDR_ARR[count]=`host $addr | grep -m1 'has address' | sed 's/^.* has address \(.*\)$/\1/'`
			fi
		fi
		if [ "$validHost" = "false" ]; then
			break
		fi
		((count=count+1))
	done
	if [ "$validHost" = "true" ]; then
		break
	fi
done


# Change the IP on the following lines of /etc/ntp.conf:
# server 192.43.244.18 iburst
# restrict 192.43.244.18 nomodify notrap nopeer noquery

set +e
sed -i '/^server.*iburst$/d' /etc/ntp.conf
sed -i '/^restrict.*noquery$/d' /etc/ntp.conf

for address in "${ADDR_ARR[@]}"
do
	sed -i "2i server $address iburst" /etc/ntp.conf
	sed -i "$ i restrict $address nomodify notrap nopeer noquery" /etc/ntp.conf
done


#sed --in-place=.`date "+%Y-%m-%d_%H:%M"` "/^server/ cserver $ADDR iburst
#    /^restrict .* nomodify notrap nopeer noquery/ crestrict $ADDR nomodify notrap nopeer noquery" $CONF_FILE

# Restart NTP server
service ntp restart > /dev/null 2>&1

echo
echo "NTP server changed to $HOST."

