#!/bin/bash

# $Id: $
# Copyright (c) 2018 NetApp, Inc.
# All rights reserved.

# Modifies log levels to INFO/DEBUG/TRACE/ERROR.
#
#
# Enforcement is as follows:
#     ownership:   root:root
#     permissions: -r-x------
#     The maintenance user is given sudo access to this script.

set -e

# Note that /home/maint/scripts/commonfunctions.sh
# needs to be owned by root and writable only by root for this to be secure
. /home/maint/scripts/commonfunctions.sh

function main() {
    if [[ $# -eq 1 ]] ; then
        sed -i -e "/log4j.appender.kaminoLog.Threshold=/ s/=.*/=$1/" /opt/netapp/vscserver/etc/kamino/log4j.properties
        sed -i -e "/log4j.rootLogger=/ s/=.*,/=$1,/" /opt/netapp/vscserver/etc/kamino/log4j.properties
        sed -i -e "/log4j.logger.com.netapp=/ s/=.*,/=$1,/" /opt/netapp/vscserver/etc/kamino/log4j.properties
        sed -i -e "/log4j.logger.com.netapp.nvpf.subplugin.kamino=/ s/=.*,/=$1,/" /opt/netapp/vscserver/etc/kamino/log4j.properties
        sed -i -e "/log4j.logger.com.netapp=/ s/=.*,/=$1,/" /opt/netapp/vscserver/etc/nvpf-subplugin-vp/log4j.properties

    fi

}

main "$@"
