#!/bin/bash
mkdir -p /opt/netapp/config
cd /opt/netapp/config
product_name="SnapCenter Plug-in for VMware vSphere"
echo "Create a jks keystore with the keypair"
keytool -genkeypair -keyalg RSA -sigalg SHA256withRSA -keysize 2048 -keystore ndbkeystore.jks -alias ndb -validity 3650 -dname "CN=`hostname -f`, OU=$product_name, O=\"NetApp, Inc\", L=Sunnyvale, ST=California, C=US" -keypass netapp -storepass netapp

echo "Get the private key from the kestore"
keytool -importkeystore -srckeystore ndbkeystore.jks -destkeystore ndbkeystore.pk2 -deststoretype pkcs12 -srcstorepass netapp -deststorepass netapp -noprompt
openssl pkcs12 -in ndbkeystore.pk2 -nocerts -nodes -out ndbkey.key -passin pass:netapp
rm ndbkeystore.pk2

echo "Get the certificate"
keytool -exportcert -keystore ndbkeystore.jks -rfc -alias ndb -file ndbcertificate.crt -storepass netapp
 
cd -

 
