#!/usr/bin/perl
use strict; 
use warnings;  
use LWP::Simple;
use JSON;
use FindBin;
use lib $FindBin::Bin;
use RBAC;
use Time::Piece;
use JSON;


sub getTimeFromCron {
    my @configVal = @{JSON::decode_json($_[0])};

    if(scalar @configVal > 0) {
        my $cronExp = "";
        foreach my $elem (@configVal) {
            my $key = '';
            my $value = '';
            foreach my $item (keys %$elem) {
                if($item =~ /^key$/i) {
                    $key = $item;
                }
                if($item =~ /^value$/i) {
                    $value = $item;
                }
            }
            if($elem->{$key} eq "CronExpression") {
                $cronExp = $elem->{$value};
                last;
            }
        }
        #print $cronExp;
        if ($cronExp eq "") {
            print "[ ERROR ] Value Not Found "
        } else {
            my @cols = split(' ',$cronExp);
            my $timeStr = $cols[2].":".$cols[1].":".$cols[0];

            my $scheduleTime = Time::Piece->strptime($timeStr, '%H:%M:%S');
            print $scheduleTime->strftime('%l:%M %p');
        }
    } else {
        print "[ ERROR ] Value Not Found ";
    }
}


sub getConfig {
    my $token = RBAC::login();
    my $ua = LWP::UserAgent->new;
    $ua->agent("$0/0.1");
    my $path = $_[0];

    my $serviceSettingsData = ServiceUtil::getServiceSettingsData();
    my $url = $serviceSettingsData->{ServiceUrls}->{ConfigurationServiceUrl2}."/${path}";
    #my $url = "http://localhost:8153/api/v1/configuration/${path}";

    # Create a request
    my $req = HTTP::Request->new(GET => $url);
    $req->header("token"=>$token);
    $req->header("Content-Length"=>0);
    $req->header("Accept"=>"application/json");

    # Pass request to the user agent and get a response back
    my $res = $ua->request($req);

    if ($res->is_success){
        #print $res->content;
        my $rspContent = JSON::decode_json($res->content);

        my $configVal = $rspContent->{configurationValue};
        if ($path eq "Schedule-DatabaseDump") {
            getTimeFromCron($configVal);
        } else {
            print $configVal;
        }
    } else {
        my $responseContent = JSON::decode_json($res->content);
        die($responseContent->{Result}->{_message}, "\n");
    }
}


if ($#ARGV >= 0) {
    getConfig($ARGV[0]);
} else {
    print "ERROR: Please provide an argument.\n"
}

#getConfig("DatabaseDumpFolderPath");       # For Folder Path
#getConfig("DatabaseDumpRetentionCount");   # For Retention Count
#getConfig("DatabaseDump");                 # For Schedule