#!/usr/bin/perl   
use strict; 
use warnings;  
use LWP::Simple;
use JSON;
use FindBin;
use lib $FindBin::Bin;
use RBAC;

my $recentBackup = $ARGV[0];
my $backupName = $ARGV[1];

sub restoreDatabase {    
    my $timeoutSeconds = 7200; 
    my $token = RBAC::login();
    my $ua = LWP::UserAgent->new;
    $ua->agent("$0/0.1");
    $ua->timeout( $timeoutSeconds );

    my $url;
    my $fileName = $_[1];
    my $serviceSettingsData = ServiceUtil::getServiceSettingsData();
    if($recentBackup) {
        $url = $serviceSettingsData->{ServiceUrls}->{JobServiceUrl}."/database/backup/recent/restore";
    } else {
        $url = $serviceSettingsData->{ServiceUrls}->{JobServiceUrl}."/database/restore?backupName=".$fileName;
    }

    # Create a request
    my $req = HTTP::Request->new(PUT => $url);
    $req->header("token"=>$token);
    $req->content_type('application/json');
    $req->content("NoData");

    # Pass request to the user agent and get a response back
    my $res = $ua->request($req);
    if ($res->is_success){
        print("success", "\n");
    } else {
        my $responseContent = JSON::decode_json($res->content);
        die($responseContent->{Result}->{_message}, "\n");
    }
}

restoreDatabase $recentBackup, $backupName;