#!/bin/bash
touch /var/log/netapp/vplatform/rotate_core.log
SMAGENT_CORE_DIR="/var/core/smagent"

rotate() {
    max_cores=20
    find_res=$(find $SMAGENT_CORE_DIR)
    if [[ -z "$find_res" ]]; then
        echo "Unable to locate smagent core directory."
    else
        date
        proglist=(smagent_vadp) #add programs that generate core to this list later
        for prog in ${proglist[@]}; do
            echo "Starting to rotate core dumps for ${prog}."
            #find timestamp after the last "-" and sort by timestamp
            cores=$(find $SMAGENT_CORE_DIR -type f -name "core-${prog}*" | \
            awk -F "-" '{print $NF,$0}' | sort -n -k1 | cut -f2- -d' ' | \
            head -n -$max_cores)
            if [[ ! -z "$cores" ]]; then
                for core in ${cores[@]}; do
                    echo $core
                done
                echo "The above cores will be removed."
                echo
                find $SMAGENT_CORE_DIR -type f -name "core-${prog}*" | \
                awk -F "-" '{print $NF,$0}' | sort -n -k1 | cut -f2- -d' ' | \
                head -n -$max_cores | xargs rm -f
            else
                echo "No cores to be deleted."
                echo
            fi
        done
    fi
}

rotate | tee -a /var/log/netapp/vplatform/rotate_core.log
