#!/bin/bash
. /home/maint/scripts/commonfunctions.sh
service_seq=( controlplane protectionservice-rbac scvservice protectionservice-backup  protectionservice-configuration protectionservice-job protectionservice-logger protectionservice-policy  protectionservice-report  protectionservice-resources protectionservice-scheduler protectionservice-storage )
input_services=("${service_seq[@]}")

if [[ $# -gt 0 ]]; then
	if [[ $1 != "all" ]]; then
		input_services=( "$@" )
	fi
fi

TEMP_ARRAY=()
for pkg in ${service_seq[@]}; do
    for stay in ${input_services[@]}; do
        KEEP=false
        if [[ ${pkg} == ${stay} ]]; then
            KEEP=true
            break
        fi
    done
    if ${KEEP}; then
        TEMP_ARRAY+=(${pkg})
    fi
done
service_seq=("${TEMP_ARRAY[@]}")
unset TEMP_ARRAY

echo "Stopping Services ....."
for (( idx=${#service_seq[@]}-1 ; idx>=0 ; idx-- )); do
	svc=${service_seq[idx]}
	serverStartStop $svc stop
	sleep 2
	echo "$svc stopping"
	if [[ $? -ne 0 ]]; then
		echo "The $svc service could not be stopped."
		echo "Exiting the process of stopping services..."
		exit 1
	fi
done
echo "Starting Services ......."
for svc in ${service_seq[@]}; do
	serverStartStop $svc start
	sleep 2
	echo "$svc starting"
	if [[ $? -ne 0 ]]; then
		echo "The  $svc service could not be started."
		echo "Exiting the process of stopping services..."
		exit 1
	fi
done
