#!/bin/bash
mkdir -p /var/log/netapp/vplatform
touch /var/log/netapp/vplatform/support_bundle_cleanup.log
SUPPORT_HOME="/support/support/"

cleanup() {
        findstamp=$(date +%Y%m%d)
		del_date=$(date -d "$findstamp - 7 days" +%Y%m%d)
		echo "Finding the support bundle files older than date: $del_date"
		res=$(find $SUPPORT_HOME)
        if [ -z "$res" ];
        then
            echo "Unable to locate to the support directory"
        else
            deltime=$(date)
            echo "Starting the delete file process $deltime"
			files=$(find $SUPPORT_HOME -name "*.zip*" -type f -ctime +6)
			echo $files
			if [ ! -z "$files" ]; then
				echo "The above files have been deleted on $deltime"
                find $SUPPORT_HOME -name "*.zip*" -type f -ctime +6 -delete
            else
				echo "No support bundle files found for deletion"
			fi
        fi
}

cleanup | tee /var/log/netapp/vplatform/support_bundle_cleanup.log
